// by Superlexx, based on IPFilter from eMule project, http://emule-project.net

// [TPT] - IP Country by Superlexx

#include "stdafx.h"
#include "emule.h"
#include "IP2Country.h"
#include "otherfunctions.h"
#include "Preferences.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CIP2Country::CIP2Country(){
	LoadFromFile();
}

CIP2Country::~CIP2Country(){
	RemoveAllIPs();
}

void CIP2Country::AddIPRange(uint32 IPfrom, uint32 IPto, CString location, CString location_iso){
	IPRange_Struct2* newFilter=new IPRange_Struct2();

	newFilter->IPstart=IPfrom;
	newFilter->IPend=IPto;
	newFilter->country=location;
	newFilter->country_iso=location_iso;
	iplist[IPfrom]=newFilter;
}

void CIP2Country::LoadFromFile(){
	CString sbuffer,sbuffer2,sbuffer3,sbuffer4,sbuffer5;
	int pos;
	char buffer[1024];
	int lenBuf = 1024;

	RemoveAllIPs();

	FILE* readFile= fopen(CString(theApp.glob_prefs->GetConfigDir())+"ip-to-country.csv", "r");
	if (readFile!=NULL) {
		while (!feof(readFile)) {
			if (fgets(buffer,lenBuf,readFile)==0) break;
			sbuffer=buffer;
			 
			// we assume that the ip-to-country.csv is valid and doesn't cause any troubles

			// get & process IP range
			sbuffer.Remove('"'); // get rid of the " signs
			pos=sbuffer.Find(',');
			sbuffer2=sbuffer.Left(pos);  // first IP number
			sbuffer=sbuffer.Right(sbuffer.GetLength()-pos-1);
			 
			pos=sbuffer.Find(',');
			sbuffer3=sbuffer.Left(pos);  // last IP number

			sbuffer=sbuffer.Right(sbuffer.GetLength()-pos-1);
			pos=sbuffer.Find(',');
			sbuffer5=sbuffer.Left(pos);  // Country ISO
			 
			pos=sbuffer.ReverseFind(',');
			sbuffer4=sbuffer.Right(sbuffer.GetLength()-pos-1); // get the long country name
			sbuffer4=sbuffer4.Left(sbuffer4.GetLength()-1);  // delete the EOL

			AddIPRange(atoi(sbuffer2),atoi(sbuffer3),sbuffer4, sbuffer5);
		}
		fclose(readFile);
	}
}


void CIP2Country::RemoveAllIPs(){
	IPRange_Struct2* search;

	std::map<uint32, IPRange_Struct2*>::const_iterator it;
	for ( it = iplist.begin(); it != iplist.end(); ++it ) {
		search=(*it).second;
		delete search;

	}

	iplist.clear();
}

CString CIP2Country::GetCountryFromIP(uint32 IP){
	if (iplist.size()==0 || IP==0) return "";

	IPRange_Struct2* search;
	IP=htonl(IP);

	std::map<uint32, IPRange_Struct2*>::const_iterator it=iplist.upper_bound(IP);
	it--;
	do {
		search=(*it).second;
		if (search->IPend<IP) return "N/A";
		if (search->IPstart<=IP && search->IPend>=IP) return search->country;
		it--;
	} while (it!=iplist.begin());
	return "N/A";
}